package com.fjhx.sale.service.sale;

import com.fjhx.customer.entity.customer.dto.CustomerDto;
import com.fjhx.customer.entity.customer.dto.CustomerSelectDto;
import com.fjhx.sale.entity.sale.po.SaleQuotation;
import com.ruoyi.common.core.service.BaseService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.sale.entity.sale.vo.SaleQuotationVo;
import com.fjhx.sale.entity.sale.dto.SaleQuotationSelectDto;
import com.fjhx.sale.entity.sale.dto.SaleQuotationDto;

import java.util.List;
import java.util.Map;


/**
 * <p>
 * 报价表 服务类
 * </p>
 *
 * @author
 * @since 2023-04-14
 */
public interface SaleQuotationService extends BaseService<SaleQuotation> {

    /**
     * 报价表分页
     */
    Page<SaleQuotationVo> getPage(SaleQuotationSelectDto dto);

    /**
     * 报价表明细
     */
    SaleQuotationVo detail(Long id);

    /**
     * 报价表新增
     */
    long add(SaleQuotationDto saleQuotationDto);

    /**
     * 报价表编辑
     */
    void edit(SaleQuotationDto saleQuotationDto);

    /**
     * 报价表删除
     */
    void delete(Long id);

    /**
     * 报价单的复制功能
     */
    void copy(SaleQuotationDto saleQuotationDto);

    /**
     * 查询这个客户的报价次数
     * @param id （客户ID）
     */
    Integer getCount(Long id);

    /**
     * 查询指定客户的每月报价总额
     * @param dto
     * @return
     */
    List<SaleQuotationVo> getAmount(CustomerDto dto);


    /**
     * 最新跟进（客户画像）
     */
    Page<SaleQuotationVo> latestFollowUp(CustomerSelectDto dto);

    /**
     * 销售统计（客户画像）
     */
    Map<String, Object> salesStatistics(CustomerDto dto);

    /**
     * 销售走势（客户画像）
     */
    Map<String, Object> salesTrend(CustomerDto dto);

    /**
     * 销售明细（客户画像）
     */
    Page<SaleQuotationVo> saleDetail(CustomerSelectDto dto);

    /**
     * 来源统计（客户分析）
     */
    Map<String,Object> sourceStatistics(CustomerDto dto);

    /**
     * 类型统计（客户分析）
     */
    Map<String, Object> typeStatistics(CustomerDto dto);

    /**
     * 趋势分析（客户分析）
     */
    Map<String, Object> trendAnalysis(CustomerDto dto);
}
